#include "G4VHit.hh"
#include "G4THitsCollection.hh"
#include "G4Allocator.hh"
#include "G4ThreeVector.hh"

class triPolRingHit : public G4VHit
{
public:

  triPolRingHit();
  ~triPolRingHit();
  triPolRingHit(const triPolRingHit&);
  const triPolRingHit& operator=(const triPolRingHit&);
  G4int operator==(const triPolRingHit&) const;

  inline void* operator new(size_t);
  inline void  operator delete(void*);

  void Draw();
  void Print();

public:
  
  void SetTrackID  (G4int track)      { trackID = track; };
  //void SetRingID(G4int ringIDval)      { ringID = ringIDval; };  
  //void SetSectorID(G4int sectorIDval)      { sectorID = sectorIDval; };  
  void SetEdep     (G4double de)      { edep = de; };
  void SetPos      (G4ThreeVector xyz){ pos = xyz; };

  G4int GetTrackID()    { return trackID; };
  //G4int GetRingID()  { return ringID; };
  //G4int GetRingID()  { return sectorID; };
  G4double GetEdep()    { return edep; };      
  G4ThreeVector GetPos(){ return pos; };
      
private:
  
  G4int         trackID;
  //G4int         ringID;
  //G4int         sectorID;
  G4double      edep;
  G4ThreeVector pos;
};
typedef G4THitsCollection<triPolRingHit> triPolRingHitsCollection;

extern G4Allocator<triPolRingHit> triPolRingHitAllocator;

inline void* triPolRingHit::operator new(size_t)
{
  void *aHit;
  aHit = (void *) triPolRingHitAllocator.MallocSingle();
  return aHit;
}

inline void triPolRingHit::operator delete(void *aHit)
{
  triPolRingHitAllocator.FreeSingle((triPolRingHit*) aHit);
}


