//
// ********************************************************************
// *                                                                  *
// *                                                                  *
// *                                                                  *
// ********************************************************************
//
 
#include "myEventAction.hh"

#include "G4Event.hh"
#include "G4EventManager.hh"
#include "G4TrajectoryContainer.hh"
#include "G4Trajectory.hh"
#include "G4ios.hh"
#include "TH2.h"
#include "G4SDManager.hh"
#include "G4THitsCollection.hh"
//#include "myRingHit.hh"
#include "myPrimaryGeneratorAction.hh"
#include "TLorentzVector.h"
#include "TRandom3.h"

#include "G4SystemOfUnits.hh"
#include "hList.hh"



//asdf TH2D *h2d401a;
//asdf TH1D *hDeDx1;
//asdf TH1D *hDeDx2;
//asdf TH2D *hDeDxVsP1;
//asdf TH2D *hDeDxVsP2;

//mcHistos_t myHistos;

class G4AttDef;

TRandom3 *randR = new TRandom3;

// ********************************************************************         
void myEventAction::SetOutTree(TTree* treeToSet)
{
  outTree = treeToSet;
}



// ********************************************************************

myEventAction::myEventAction(myPrimaryGeneratorAction* pri)
 :primary(pri)
{ }

// ********************************************************************
 
myEventAction::~myEventAction()
{}

// ********************************************************************
//G4double myEventAction::GetEdep(){
// G4int rIDmax = 24;
// G4int sIDmax = 32;
//G4double eDep = 0.0;
//for (G4int rID=0;rID<rIDmax;rID++) {
//  for (G4int sID=0;sID<sIDmax;sID++) {
//    eDep += ringEnergy[rID][sID];
//  }
//}
//return eDep;
//}
// ********************************************************************
void myEventAction::BeginOfEventAction(const G4Event* evt)
{
  G4int event_id;
  event_id = evt->GetEventID();
  energyPaddle1 = 0.0;
  energyPaddle2 = 0.0;
  for(int iRow = 0; iRow < 10; iRow++){
    for(int iCol = 0; iCol < 10; iCol++){
      crystalEnergy[iRow][iCol] = 0.0;
    }
  }
 
}

// ********************************************************************
 
void myEventAction::EndOfEventAction(const G4Event* evt)
{
  G4int event_id = evt->GetEventID();

  G4TrajectoryContainer* trajectoryContainer = evt->GetTrajectoryContainer();
  G4int n_trajectories = 0;
  if (trajectoryContainer) n_trajectories = trajectoryContainer->entries();

  extern struct mcHistos_t myHistos;

  //Fill histograms
  //G4cout<<"energyPaddle1/MeV = "<<energyPaddle1/MeV<<G4endl;
  //myHistos.hDeDx1->Fill(energyPaddle1/MeV);
  //myHistos.hDeDx2->Fill(energyPaddle2/MeV);
  //myHistos.hDeDxVsP1->Fill(primary->GetBeamMomentum(),energyPaddle1/MeV);

  crystalArrayPtr->x = primary->GetPosX()/cm;
  crystalArrayPtr->y = primary->GetPosY()/cm;
  crystalArrayPtr->energy = primary->GetEnergy()/MeV;

  for(int iRow = 0; iRow < 10; iRow++){
    for(int iCol = 0; iCol < 10; iCol++){
      if (crystalEnergy[iRow][iCol]/MeV > 1.0){
	crystalArrayPtr->row->push_back(iRow+1);
	crystalArrayPtr->column->push_back(iCol+1);
	crystalArrayPtr->eDep->push_back(crystalEnergy[iRow][iCol]/MeV);
      }
    }
  }

  outTree->Fill();

  
  
  // periodic printing
  if (event_id%5000 == 0) {
    G4cout << ">>> Event " << evt->GetEventID() << G4endl;
  }
}

// ********************************************************************
