//
// ********************************************************************
// *                                                                  *
// * Section to Record data from each Event                           *
// * Called via the constructor of myRunAction                 *
// *                                                                  *
// ********************************************************************
//

#include "myRun.hh"
#include "G4Event.hh"
#include "G4HCofThisEvent.hh"
#include "G4SDManager.hh"

// ********************************************************************
// *                                                                  *
// *  Gets ID of Collected Items                                      *
// *                                                                  *
// ********************************************************************

myRun::myRun()
{
}

// ********************************************************************

myRun::~myRun()
{;}

// ********************************************************************
// *                                                                  *
// *  Gets values of ID and put into mapSum.                          *
// *                                                                  *
// ********************************************************************

void myRun::RecordEvent(const G4Event* evt)
{
  size_t    i,ncollections;
  G4HCofThisEvent* HCE = evt->GetHCofThisEvent();
  if(!HCE) return;
  ncollections= HCE->GetNumberOfCollections();

  numberOfEvent++;

  if(round(numberOfEvent/1000)*1000==numberOfEvent) G4cout << "Reached Event Number " << numberOfEvent << G4endl;
  for(i=0;i<ncollections;i++)
  {
      G4THitsMap<G4double>* evtMap = (G4THitsMap<G4double>*)(HCE->GetHC(colIDSum[i]));
      mapSum[i] += *evtMap;
  }
}

// ********************************************************************

G4double myRun::GetTotal(const G4THitsMap<G4double> &map) const
{
  G4double tot = 0.;
  std::map<G4int,G4double*>::iterator itr = map.GetMap()->begin();
  for(; itr != map.GetMap()->end(); itr++) 
  { tot += *(itr->second); }
  return tot;
}

// ********************************************************************

G4double myRun::FindMinimum(const G4THitsMap<G4double> &map) const
{
 G4double val = DBL_MAX;
  std::map<G4int,G4double*>::iterator itr = map.GetMap()->begin();
  for(; itr != map.GetMap()->end(); itr++) 
  { if(val>*(itr->second)) val = *(itr->second); }
  return val;
}


  
